<template>
  <div class="theme-switch global-switch">
    <el-switch
      class="mt-2"
      style="margin-left: 24px"
      inline-prompt
      size="large switch-input"
      name="theme-switch"
      :active-icon="SunIcon"
      :inactive-icon="MoonIcon"
      :active-value="!isDark"
      :inactive-value="isDark"
      @change="toggleGlobalDarkMode"
    />
    <label
      v-if="isShowlabel"
      for="theme-switch"
      :class="{ 'sr-only': hideLabel }"
      class="font-medium"
      :style="{ 'min-width': '40px' }"
      >{{ $t(displayMode) }}</label
    >
  </div>
</template>
<script setup lang="ts">
import { store } from "@/store";
import { EnumSelectedThemeMode } from "~~/models/enums/enumSelectedThemeMode";
import MoonIcon from "~/assets/icons/moon_fill.svg?component";
import SunIcon from "~/assets/icons/sun_fill.svg?component";

defineComponent({
  name: "ModernSwitch",
  components: {
    MoonIcon,
    SunIcon,
  },
});
const props = defineProps({
  hideLabel: {
    type: Boolean,
    required: false,
    default: () => false,
  },
  isDark: {
    type: Boolean,
    required: true,
  },
  isShowlabel: {
    type: Boolean,
    default: false,
  },
});
const emit = defineEmits<{
  (e: "update:isDark", isDark: boolean): void;
}>();
const displayMode = ref("Dark");
const colorState = useState("color-config");
const lightColorState = useState("lightColorConfig");
const darkColorState = useState("darkColorConfig");
const updateColorPreference = (
  isDark: boolean,
  currentColorState: any,
  themeMode: EnumSelectedThemeMode
) => {
  colorState.value = currentColorState;
  emit("update:isDark", isDark);
  store.commit("updateSelectedThemeMode", themeMode);
};
const toggleGlobalDarkMode = () => {
  if (props.isDark) {
    updateColorPreference(false, darkColorState, EnumSelectedThemeMode.Dark);
  } else {
    updateColorPreference(true, lightColorState, EnumSelectedThemeMode.Light);
  }
};
watch(
  () => store.state.selectedThemeMode,
  () => {
    if (store.state.selectedThemeMode === EnumSelectedThemeMode.Dark) {
      displayMode.value = "Dark";
      emit("update:isDark", false);
    } else {
      displayMode.value = "Light";
      emit("update:isDark", true);
    }
  },
  { immediate: true }
);
if (!store.state.isSwitchComponentCallBefore) {
  toggleGlobalDarkMode();
  store.commit("updateIsSwitchComponentCallBefore", true);
}
</script>

<style lang="scss">
.theme-switch {
  display: flex;
  align-items: center;
  gap: 0.5rem;
  font-size: 14px;
  label {
    user-select: none;
  }
  .el-switch {
    margin-top: 0px;
    margin-left: 0px !important;

    &__core {
      border: 1px solid var(--background3);
      background: var(--background3);
      box-shadow: var(--box-shadow-simle);
    }

    &__action {
      background: var(--text5);
      opacity: 80%;
    }
  }
  &.global-switch {
    pointer-events: none;
    label {
      color: var(--text3);
    }
    .el-switch__core {
      border-color: transparent;
      --L950: linear-gradient(
          rgba(255, 255, 255, 0.05),
          rgba(255, 255, 255, 0.05)
        ),
        linear-gradient(var(--background5), var(--background5));
      background: var(--L950);
      width: 64px;
      height: 32px;
      border-radius: 16px;
      pointer-events: auto;
      .el-switch__action,
      .el-switch__inner {
        width: 24px;
        height: 24px;
        top: 50%;
        transform: translateY(-50%);
        .el-icon {
          width: 24px;
          height: 24px;
          svg {
            width: 24px;
            height: 24px;
            opacity: 50%;
          }
        }
      }

      .el-switch__inner {
        left: 35px;
        opacity: 50%;
      }
      .el-switch__action {
        border: solid 2px var(--background5);
        left: 4px;
      }
    }
  }
  &.global-switch {
    .is-checked {
      .el-switch__inner {
        left: 20px;
      }
      .el-switch__action {
        left: 52px;
      }
    }
  }
}
[theme-color="global_light_01"] {
  .theme-switch {
    &.global-switch {
      .el-switch__core {
        --L950: linear-gradient(rgba(23, 23, 23, 0.05), rgba(23, 23, 23, 0.05)),
          linear-gradient(var(--background5), var(--background5));
      }
    }
  }
}
</style>
